diff --git a/test/unit/schema_files_test.rb b/test/unit/schema_files_test.rb
index 2d10237..aa06f75 100644
--- a/test/unit/schema_files_test.rb
+++ b/test/unit/schema_files_test.rb
@@ -1462,8 +1462,21 @@ class SchemaFilesTest < Minitest::Test
     assert_equal "https://json-schema.org/draft/2020-12/schema", doc["$schema"]
     assert_equal "hive-daemon-status",
                  doc.dig("$defs", "SuccessPayload", "properties", "schema", "const")
+    assert_equal 2,
+                 doc.dig("$defs", "SuccessPayload", "properties", "schema_version", "const"),
+                 "v2 is the current version (additive consistency block)"
+  end
+
+  # v1 remains for pinned consumers; it predates the consistency block.
+  def test_hive_daemon_status_v1_schema_file_remains_for_back_compat
+    path = Hive::Schemas.schema_path("hive-daemon-status", version: 1)
+    assert File.exist?(path), "v1 schema file missing: #{path}"
+
+    doc = JSON.parse(File.read(path))
     assert_equal 1,
                  doc.dig("$defs", "SuccessPayload", "properties", "schema_version", "const")
+    refute doc.dig("$defs", "SuccessPayload", "properties").key?("consistency"),
+           "v1 must not gain the v2 consistency key"
   end
 
   def test_hive_daemon_status_required_keys_match_producer_emission
@@ -1472,13 +1485,60 @@ class SchemaFilesTest < Minitest::Test
     # The producer's exhaustive key set (kept in sync with
     # Hive::Commands::Daemon#status_daemon's JSON.generate call). The three
     # service_* fields are always emitted (null on probe failure), so they
-    # are required-but-nullable in the schema.
+    # are required-but-nullable in the schema; `consistency` is the v2
+    # additive block (null on probe failure).
     producer_required = %w[
       schema schema_version ok running pid uptime_sec pid_file log_file
-      service_installed service_enabled unit_path current_version update_nudge
+      service_installed service_enabled unit_path consistency current_version
+      update_nudge
     ].sort
     assert_equal producer_required, schema_required,
-                 "schema/producer required-key drift in hive-daemon-status.v1.json"
+                 "schema/producer required-key drift in hive-daemon-status.v2.json"
+  end
+
+  # ── hive-web-install / hive-web-stop / hive-web-status (U4) ─────────
+
+  def test_hive_web_schemas_exist_and_pin_their_versions
+    %w[hive-web-install hive-web-stop hive-web-status].each do |name|
+      path = Hive::Schemas.schema_path(name)
+      assert File.exist?(path), "schema file missing: #{path}"
+
+      doc = JSON.parse(File.read(path))
+      assert_equal "https://json-schema.org/draft/2020-12/schema", doc["$schema"]
+      assert_equal name, doc.dig("$defs", "SuccessPayload", "properties", "schema", "const")
+      assert_equal 1, doc.dig("$defs", "SuccessPayload", "properties", "schema_version", "const")
+    end
+  end
+
+  def test_hive_web_install_required_keys_match_producer_emission
+    doc = JSON.parse(File.read(Hive::Schemas.schema_path("hive-web-install")))
+    schema_required = doc.dig("$defs", "SuccessPayload", "required").sort
+    producer_required = %w[
+      schema schema_version ok outcome platform target_path restarted
+    ].sort
+    assert_equal producer_required, schema_required,
+                 "schema/producer required-key drift in hive-web-install.v1.json"
+  end
+
+  def test_hive_web_status_required_keys_match_producer_emission
+    doc = JSON.parse(File.read(Hive::Schemas.schema_path("hive-web-status")))
+    schema_required = doc.dig("$defs", "SuccessPayload", "required").sort
+    producer_required = %w[
+      schema schema_version ok platform unit_path service_installed
+      service_enabled url port_listening health_ok
+    ].sort
+    assert_equal producer_required, schema_required,
+                 "schema/producer required-key drift in hive-web-status.v1.json"
+  end
+
+  def test_hive_setup_schema_exists_and_pins_version
+    path = Hive::Schemas.schema_path("hive-setup")
+    assert File.exist?(path), "schema file missing: #{path}"
+
+    doc = JSON.parse(File.read(path))
+    assert_equal "https://json-schema.org/draft/2020-12/schema", doc["$schema"]
+    assert_equal "hive-setup", doc.dig("$defs", "SuccessPayload", "properties", "schema", "const")
+    assert_equal 1, doc.dig("$defs", "SuccessPayload", "properties", "schema_version", "const")
   end
 
   # ── hive-daemon-stop ───────────────────────────────────────────────────
diff --git a/test/unit/web/config_test.rb b/test/unit/web/config_test.rb
index a9ed238..15d2534 100644
--- a/test/unit/web/config_test.rb
+++ b/test/unit/web/config_test.rb
@@ -63,4 +63,23 @@ class WebConfigTest < Minitest::Test
   def test_blank_web_session_secret_file_is_rejected
     assert_web_config_error({ "session_secret_file" => "  " }, /web\.session_secret_file/)
   end
+
+  # ── web.auth (U1: local-mode auth selector) ────────────────────────
+
+  def test_web_auth_defaults_to_auto
+    with_tmp_global_config do
+      assert_equal "auto", Hive::Config.load_global_web["auth"]
+    end
+  end
+
+  def test_web_auth_enum_is_enforced
+    %w[none github auto].each do |mode|
+      with_tmp_global_config do |home|
+        File.write(File.join(home, "config.yml"), { "web" => { "auth" => mode } }.to_yaml)
+        assert_equal mode, Hive::Config.load_global_web["auth"]
+      end
+    end
+
+    assert_web_config_error({ "auth" => "openid" }, /web\.auth in .* must be one of auto, none, github/)
+  end
 end
diff --git a/test/unit/web/web_command_test.rb b/test/unit/web/web_command_test.rb
index 11de4ab..a43b98a 100644
--- a/test/unit/web/web_command_test.rb
+++ b/test/unit/web/web_command_test.rb
@@ -13,7 +13,7 @@ class WebCommandTest < Minitest::Test
         command = Hive::Commands::Web.new
         # Singleton override instead of minitest/mock (not bundled): the
         # checkout itself contains web/, so the fallback path would resolve.
-        command.define_singleton_method(:rails_app_dir) { nil }
+        command.define_singleton_method(:locate_app_dir) { nil }
         err = assert_raises(SystemExit) do
           capture_io { command.call }
         end
@@ -48,6 +48,7 @@ class WebCommandTest < Minitest::Test
       assert_empty err, "an https origin implies a fronting proxy — no warning"
     end
   end
+
   # Drive the full "app found" path with a stub Rails app: db:prepare
   # failure raises typed guidance (never a raw backtrace looping under the
   # container supervisor), and a passing prepare reaches Kernel.exec with
@@ -115,4 +116,175 @@ class WebCommandTest < Minitest::Test
       end
     end
   end
+
+  # ── U1: auth-mode resolution + refusal matrix ────────────────────────
+
+  def test_loopback_auto_exports_noauth_env
+    with_tmp_global_config do
+      with_stub_rails_app(prepare_exit: 0) do
+        caught = exec_catch do
+          capture_io { Hive::Commands::Web.new.call }
+        end
+        assert_equal "1", caught.env[Hive::Web::AuthMode::LOCAL_NOAUTH_ENV],
+                     "loopback bind + auto + no owner must export the tokenless-local-session env"
+      end
+    end
+  end
+
+  def test_web_auth_github_on_loopback_exports_no_noauth_env
+    with_tmp_global_config do
+      with_stub_rails_app(prepare_exit: 0) do
+        write_global_web_auth("github")
+        caught = exec_catch do
+          capture_io { Hive::Commands::Web.new.call }
+        end
+        refute caught.env[Hive::Web::AuthMode::LOCAL_NOAUTH_ENV],
+               "explicit web.auth: github must keep the device-flow gate even on loopback"
+      end
+    end
+  end
+
+  def test_configured_owner_on_loopback_keeps_github_gate
+    with_tmp_global_config do
+      with_stub_rails_app(prepare_exit: 0) do
+        write_global_web_owner("somebody")
+        caught = exec_catch do
+          capture_io { Hive::Commands::Web.new.call }
+        end
+        refute caught.env[Hive::Web::AuthMode::LOCAL_NOAUTH_ENV],
+               "a configured github.owner means an owner gate exists — no no-auth session"
+      end
+    end
+  end
+
+  # Docker regression guard: the supervisor boots `hive web --bind 0.0.0.0`
+  # with an owner configured (hivebox). The refusal must NOT fire and the
+  # no-auth env must NOT be exported — the device-flow gate is the contract.
+  def test_non_loopback_auto_with_owner_boots_without_noauth_env
+    with_tmp_global_config do
+      with_stub_rails_app(prepare_exit: 0) do
+        write_global_web_owner("somebody")
+        caught = exec_catch do
+          capture_io { Hive::Commands::Web.new(bind: "0.0.0.0").call }
+        end
+        refute caught.env[Hive::Web::AuthMode::LOCAL_NOAUTH_ENV]
+      end
+    end
+  end
+
+  def test_non_loopback_auto_without_owner_is_refused_before_boot
+    with_tmp_global_config do
+      with_stub_rails_app(prepare_exit: 0) do
+        error = assert_raises(Hive::Commands::Web::PublicNoAuthRefused) do
+          capture_io { Hive::Commands::Web.new(bind: "0.0.0.0").call }
+        end
+        assert_match(/not loopback/, error.message)
+        assert_match(/--allow-public-noauth/, error.message, "the refusal must carry the exact fix")
+        assert_match(/web\.auth: github/, error.message)
+      end
+    end
+  end
+
+  def test_allow_public_noauth_flag_boots_with_the_env_set
+    with_tmp_global_config do
+      with_stub_rails_app(prepare_exit: 0) do
+        caught = exec_catch do
+          capture_io { Hive::Commands::Web.new(bind: "0.0.0.0", allow_public_noauth: true).call }
+        end
+        assert_equal "1", caught.env[Hive::Web::AuthMode::LOCAL_NOAUTH_ENV],
+                     "the unsafe escape hatch must still boot in no-auth mode"
+      end
+    end
+  end
+
+  def test_web_auth_none_on_loopback_exports_noauth_env
+    with_tmp_global_config do
+      with_stub_rails_app(prepare_exit: 0) do
+        write_global_web_auth("none")
+        caught = exec_catch do
+          capture_io { Hive::Commands::Web.new.call }
+        end
+        assert_equal "1", caught.env[Hive::Web::AuthMode::LOCAL_NOAUTH_ENV]
+      end
+    end
+  end
+
+  def test_web_auth_none_on_non_loopback_is_refused
+    with_tmp_global_config do
+      with_stub_rails_app(prepare_exit: 0) do
+        write_global_web_auth("none")
+        error = assert_raises(Hive::Commands::Web::PublicNoAuthRefused) do
+          capture_io { Hive::Commands::Web.new(bind: "192.168.1.10").call }
+        end
+        assert_match(/--allow-public-noauth/, error.message)
+      end
+    end
+  end
+
+  def test_refusal_happens_before_db_prepare_or_exec
+    with_tmp_global_config do
+      with_stub_rails_app(prepare_exit: 0) do
+        marker = File.join(Hive::Paths.state_home, "web-storage")
+        FileUtils.rm_rf(marker)
+        # The stub app's bin/rails would run on db:prepare; assert the
+        # refusal short-circuits before any child process / exec.
+        with_kernel_exec_stubbed do
+          # A refusal must raise PublicNoAuthRefused, never reach exec (which
+          # would surface as ExecCaught instead).
+          error = assert_raises(Hive::Error) do
+            capture_io { Hive::Commands::Web.new(bind: "0.0.0.0").call }
+          end
+          assert_instance_of Hive::Commands::Web::PublicNoAuthRefused, error,
+                             "the no-auth refusal must fire before any exec"
+        end
+        # db:prepare would have created the storage dir — its absence proves
+        # the refusal fired before any boot work started.
+        refute File.exist?(marker), "the refusal must fire before db:prepare runs"
+      end
+    end
+  end
+
+  private
+
+  # Stub Kernel.exec (which `hive web` ends in) for the duration of the
+  # block. Captures the ORIGINAL method object before stubbing and always
+  # restores it in ensure — remove_method would delete the module-function
+  # singleton entirely and break every later caller.
+  def with_kernel_exec_stubbed
+    original = Kernel.method(:exec)
+    Kernel.define_singleton_method(:exec) do |env, *argv|
+      raise ExecCaught.new(env, argv)
+    end
+    begin
+      yield
+    rescue ExecCaught => e
+      e
+    ensure
+      Kernel.define_singleton_method(:exec, original)
+    end
+  end
+
+  def exec_catch
+    caught = with_kernel_exec_stubbed { yield }
+    raise "expected Kernel.exec to be reached" unless caught.is_a?(ExecCaught)
+
+    caught
+  end
+
+  def write_global_web_auth(value)
+    path = File.join(Hive::Paths.config_home, "config.yml")
+    data = YAML.safe_load(File.read(path)) || {}
+    data["web"] ||= {}
+    data["web"]["auth"] = value
+    File.write(path, YAML.dump(data))
+  end
+
+  def write_global_web_owner(login)
+    path = File.join(Hive::Paths.config_home, "config.yml")
+    data = YAML.safe_load(File.read(path)) || {}
+    data["web"] ||= {}
+    data["web"]["github"] ||= {}
+    data["web"]["github"]["owner"] = login
+    File.write(path, YAML.dump(data))
+  end
 end
diff --git a/test/unit/web_app/provisioner_test.rb b/test/unit/web_app/provisioner_test.rb
new file mode 100644
index 0000000..6105124
--- /dev/null
+++ b/test/unit/web_app/provisioner_test.rb
@@ -0,0 +1,211 @@
+require "test_helper"
+require "hive/web_app/provisioner"
+
+class WebAppProvisionerTest < Minitest::Test
+  include HiveTestHelper
+
+  # A fake Rails app skeleton: just enough for discovery (config/application.rb)
+  # and, when built, the managed manifest marker.
+  def make_app(dir)
+    FileUtils.mkdir_p(File.join(dir, "config"))
+    File.write(File.join(dir, "config", "application.rb"), "# rails app marker")
+    dir
+  end
+
+  def build(data_home, **opts)
+    # Default tests to a gem-only machine: no source checkout present.
+    Hive::WebApp::Provisioner.new(data_home: data_home,
+                                  checkout_dir: File.join(data_home, "no-checkout"), **opts)
+  end
+
+  # ── discovery precedence ───────────────────────────────────────────
+
+  def test_env_override_takes_precedence
+    with_tmp_dir do |dir|
+      env_app = make_app(File.join(dir, "env-app"))
+      managed = File.join(dir, "managed", "1.0.0")
+      make_app(managed)
+
+      prov = build(dir, env: { "HIVEBOX_WEB_APP_DIR" => env_app })
+      assert_equal env_app, prov.locate
+    end
+  end
+
+  def test_checkout_takes_precedence_over_managed
+    with_tmp_dir do |dir|
+      checkout = make_app(File.join(dir, "checkout"))
+      managed = make_app(File.join(dir, "managed", "1.0.0"))
+
+      prov = Hive::WebApp::Provisioner.new(
+        data_home: dir, version: "1.0.0", checkout_dir: checkout
+      )
+      assert_equal checkout, prov.locate
+    end
+  end
+
+  def test_locate_returns_nil_when_nothing_exists
+    with_tmp_dir do |dir|
+      assert_nil build(dir).locate
+    end
+  end
+
+  # ── managed dir + manifest ─────────────────────────────────────────
+
+  def test_managed_app_dir_is_version_pinned_under_data_home
+    with_tmp_dir do |dir|
+      prov = build(dir, version: "9.9.9")
+      assert_equal File.join(dir, "web", "app", "9.9.9"), prov.managed_app_dir
+    end
+  end
+
+  def test_provision_is_idempotent_when_manifest_matches
+    with_tmp_dir do |dir|
+      managed = make_app(File.join(dir, "web", "app", "1.2.3"))
+      File.write(File.join(managed, "1.2.3.manifest"), "1.2.3")
+      downloads = []
+
+      result = build(dir, version: "1.2.3", downloader: ->(*argv) { downloads << argv; false }).provision!
+
+      assert_equal managed, result
+      assert_empty downloads, "a valid manifest must be a no-op (no network)"
+    end
+  end
+
+  # ── provision pipeline ─────────────────────────────────────────────
+
+  def fake_downloader(ok: true)
+    ->(_url, dest, _checksum) { FileUtils.mkdir_p(File.dirname(dest)); FileUtils.touch(dest); ok }
+  end
+
+  def recording_runner
+    calls = []
+    recorder = lambda { |argv, chdir: nil, env: nil|
+      calls << [ argv, chdir, env ]
+      true
+    }
+    def recorder.calls = @calls
+    recorder.instance_variable_set(:@calls, calls)
+    recorder
+  end
+
+  def test_provision_downloads_extracts_builds_and_precompiles
+    with_tmp_dir do |dir|
+      runner = recording_runner
+      managed = File.join(dir, "web", "app", "4.5.6")
+
+      result = Hive::WebApp::Provisioner.new(
+        data_home: dir, version: "4.5.6", checkout_dir: File.join(dir, "no-checkout"),
+        downloader: fake_downloader, runner: runner
+      ).provision!
+
+      assert_equal managed, result
+      assert File.directory?(managed), "extracted app must land in the managed dir"
+      assert File.file?(File.join(managed, "4.5.6.manifest")), "manifest marker must be written"
+
+      argvs = runner.calls.map { |c| c[0] }
+      tar_call = argvs.find { |a| a[0] == "tar" }
+      assert tar_call, "tar must extract the downloaded tarball"
+      assert_match(%r{-C .*web/app/4\.5\.6\.extract-\d+\z}, tar_call.join(" "))
+      bundle_call = runner.calls.find { |c| c[0] == ["bundle", "install", "--deployment", "--without", "development", "test", "--path", File.join(managed, "vendor", "bundle")] }
+      assert bundle_call, "bundle install must run deployment-style with a local vendor path"
+      assert_equal managed, bundle_call[1], "bundle must run inside the app dir"
+
+      precompile_call = runner.calls.find { |c| c[0] == ["bin/rails", "assets:precompile"] }
+      assert precompile_call, "assets:precompile must run"
+      assert_equal "assets-build-dummy", precompile_call[2]["SECRET_KEY_BASE"], "dummy secret mirrors the Dockerfile"
+      refute File.exist?(precompile_call[2]["HIVEBOX_STORAGE_DIR"]), "build storage dir must be cleaned up"
+    end
+  end
+
+  def test_provision_download_failure_is_typed
+    with_tmp_dir do |dir|
+      error = assert_raises(Hive::WebApp::Provisioner::ProvisioningFailed) do
+        Hive::WebApp::Provisioner.new(
+          data_home: dir, version: "1.0.0", checkout_dir: File.join(dir, "no-checkout"),
+          downloader: fake_downloader(ok: false)
+        ).provision!
+      end
+      assert_match(/could not download/, error.message)
+      assert_match(%r{github\.com/.*/releases/download}, error.message)
+    end
+  end
+
+  def test_provision_bundle_failure_names_the_missing_toolchain
+    with_tmp_dir do |dir|
+      error = assert_raises(Hive::WebApp::Provisioner::ProvisioningFailed) do
+        Hive::WebApp::Provisioner.new(
+          data_home: dir, version: "1.0.0", checkout_dir: File.join(dir, "no-checkout"),
+          downloader: fake_downloader,
+          runner: ->(argv, chdir: nil, env: nil) { argv[0] == "tar" }
+        ).provision!
+      end
+      assert_match(/build-essential/, error.message)
+      assert_match(/xcode-select/, error.message)
+    end
+  end
+
+  def test_version_mismatch_triggers_repair
+    with_tmp_dir do |dir|
+      # A managed app for a stale version with a stale manifest: repair!
+      # must re-provision (downloads again) rather than return the stale dir.
+      stale = make_app(File.join(dir, "web", "app", "0.9.0"))
+      File.write(File.join(stale, "0.9.0.manifest"), "0.9.0")
+      runner = recording_runner
+
+      result = Hive::WebApp::Provisioner.new(
+        data_home: dir, version: "1.0.0", checkout_dir: File.join(dir, "no-checkout"),
+        downloader: fake_downloader, runner: runner
+      ).repair!
+
+      assert_equal File.join(dir, "web", "app", "1.0.0"), result
+      assert File.file?(File.join(result, "1.0.0.manifest"))
+    end
+  end
+
+  def test_repair_noops_when_checkout_app_exists
+    with_tmp_dir do |dir|
+      checkout = make_app(File.join(dir, "elsewhere"))
+      downloads = []
+      prov = Hive::WebApp::Provisioner.new(
+        data_home: dir, version: "1.0.0", checkout_dir: File.join(dir, "no-checkout"),
+        env: { "HIVEBOX_WEB_APP_DIR" => checkout },
+        downloader: ->(*argv) { downloads << argv; true }
+      )
+      assert_equal checkout, prov.repair!
+      assert_empty downloads
+    end
+  end
+
+  # ── prune policy ───────────────────────────────────────────────────
+
+  def test_prune_keeps_last_two_versions
+    with_tmp_dir do |dir|
+      root = File.join(dir, "web", "app")
+      %w[1.0.0 1.0.1 1.0.2].each { |v| make_app(File.join(root, v)) }
+      prov = Hive::WebApp::Provisioner.new(data_home: dir, version: "1.0.2")
+      prov.send(:prune_old_versions)
+
+      kept = Dir.children(root).sort
+      assert_equal %w[1.0.1 1.0.2], kept, "prune must keep the newest 2 versions"
+    end
+  end
+
+  def test_prune_never_touches_the_current_version
+    with_tmp_dir do |dir|
+      root = File.join(dir, "web", "app")
+      %w[0.1.0 0.2.0].each { |v| make_app(File.join(root, v)) }
+      prov = Hive::WebApp::Provisioner.new(data_home: dir, version: "9.9.9")
+      prov.send(:prune_old_versions)
+
+      kept = Dir.children(root).sort
+      assert_equal %w[0.1.0 0.2.0], kept
+    end
+  end
+
+  # ── release asset naming ───────────────────────────────────────────
+
+  def test_release_asset_name_pins_the_version
+    assert_equal "hive-web-app-0.3.2.tar.gz",
+                 Hive::WebApp::Provisioner.release_asset_name("0.3.2")
+  end
+end
diff --git a/web/app/controllers/application_controller.rb b/web/app/controllers/application_controller.rb
index 2a1e5e2..2c8aa2c 100644
--- a/web/app/controllers/application_controller.rb
+++ b/web/app/controllers/application_controller.rb
@@ -49,7 +49,23 @@ class ApplicationController < ActionController::Base
     session[:github_login]
   end
 
+  # Local no-auth mode: `hive web` exports HIVEBOX_LOCAL_NOAUTH=1 when the
+  # resolved auth mode is "none" (loopback bind + no configured owner). The
+  # UI then treats any request arriving FROM a loopback address as a signed-in
+  # single-user local session — no device-flow, no cookies. Defense in depth:
+  # a non-loopback remote_ip under that env is still refused, so a public
+  # bind (mis)configured with the env set does not silently open the box.
+  # The Docker/hivebox path never sets the env, so its owner gate is
+  # byte-for-byte unchanged.
+  def local_noauth_request?
+    return false unless ENV[Hive::Web::AuthMode::LOCAL_NOAUTH_ENV] == "1"
+
+    remote_ip = request.remote_ip.to_s
+    remote_ip == "127.0.0.1" || remote_ip == "::1"
+  end
+
   def require_login
+    return if local_noauth_request?
     return redirect_to login_path unless current_login
 
     # Sessions must track the CURRENT owner, not the owner at sign-in time:
diff --git a/web/app/controllers/daemon_controller.rb b/web/app/controllers/daemon_controller.rb
new file mode 100644
index 0000000..b5acf72
--- /dev/null
+++ b/web/app/controllers/daemon_controller.rb
@@ -0,0 +1,147 @@
+require "open3"
+require "hive/daemon/consistency_probe"
+
+# Daemon health surface for the dashboard (U7).
+#
+# GET  /daemon/status  — JSON: deep-health payload + the U5 binary
+#                        consistency probe, computed IN-PROCESS via the gem
+#                        (pidfile probe + consistency probe). No shell, no
+#                        subprocess for reads.
+# POST /daemon/repair  — the single write action: a bounded subprocess (own
+#                        process group, hard wall-clock deadline, capped
+#                        output — the same discipline as
+#                        TasksController#bounded_diff) running
+#                        `hive daemon start --detach` when the daemon is
+#                        down, or `hive daemon install --force` when the
+#                        binary/version drifted. The timeout is shorter
+#                        than the unit's 900s worst-case stop drain, and a
+#                        timeout renders a clear partial-failure state.
+#
+# Both routes sit behind the standard auth gate (owner session or U1
+# loopback no-auth session) inherited from ApplicationController.
+class DaemonController < ApplicationController
+  # Hard wall-clock bound for the repair subprocess. Deliberately well
+  # below the daemon unit's TimeoutStopSec=900 drain ceiling: a wedged
+  # repair must surface as a typed partial-failure, not pin a Puma thread
+  # for 15 minutes.
+  REPAIR_TIMEOUT_SEC = Integer(ENV.fetch("HIVEBOX_DAEMON_REPAIR_TIMEOUT_SEC", 120))
+  REPAIR_MAX_BYTES = 64 * 1024
+
+  class RepairFailed < Hive::Error; end
+
+  def status
+    probe = consistency_probe
+    render json: {
+      ok: true,
+      daemon: {
+        running: probe.running,
+        pid: probe.pid,
+        drift_kind: probe.drift_kind,
+        cli_bin_path: probe.cli_bin_path,
+        unit_bin_path: probe.unit_bin_path,
+        live_bin_path: probe.live_bin_path
+      }
+    }
+  end
+
+  def repair
+    before = consistency_probe
+    argv =
+      if before.drifted?
+        [ repair_binary, "daemon", "install", "--force" ]
+      else
+        [ repair_binary, "daemon", "start", "--detach" ]
+      end
+
+    output, truncated = bounded_subprocess(argv)
+    after = consistency_probe
+    if after.running && !after.drifted?
+      render json: {
+        ok: true,
+        action: argv[1..].join(" "),
+        output: output,
+        output_truncated: truncated,
+        daemon: daemon_payload(after)
+      }
+    else
+      render json: {
+        ok: false,
+        action: argv[1..].join(" "),
+        output: output,
+        output_truncated: truncated,
+        message: "the repair command ran but the daemon did not come back healthy; " \
+                 "inspect `hive daemon status --json` and the daemon logs",
+        daemon: daemon_payload(after)
+      }, status: :service_unavailable
+    end
+  rescue RepairFailed => e
+    render json: {
+      ok: false,
+      action: "repair",
+      message: e.message,
+      daemon: daemon_payload(consistency_probe)
+    }, status: :service_unavailable
+  end
+
+  private
+
+  def daemon_payload(probe)
+    {
+      running: probe.running,
+      pid: probe.pid,
+      drift_kind: probe.drift_kind,
+      cli_bin_path: probe.cli_bin_path,
+      unit_bin_path: probe.unit_bin_path,
+      live_bin_path: probe.live_bin_path
+    }
+  end
+
+  def consistency_probe
+    Hive::Daemon::ConsistencyProbe.new(pid: live_daemon_pid).call
+  end
+
+  def live_daemon_pid
+    HealthController::DaemonProbe.new.read_live_pid
+  end
+
+  # The hive binary to repair with. The gem resolves the same InvokedBinary
+  # the service installers bake — falling back to PATH lookup inside the
+  # web process.
+  def repair_binary
+    Hive::InvokedBinary.path || "hive"
+  end
+
+  # Same discipline as TasksController#bounded_diff: own process group, a
+  # hard CLOCK_MONOTONIC deadline, output to a tempfile, and only the first
+  # REPAIR_MAX_BYTES are returned (with an explicit truncation flag). On
+  # timeout the whole process group is SIGKILLed so a wedged `daemon stop`
+  # drain can never hold the repair request open.
+  def bounded_subprocess(argv)
+    log = Tempfile.create("hivebox-daemon-repair")
+    pid = Process.spawn(*argv, pgroup: true, out: log.path, err: log.path)
+    deadline = Process.clock_gettime(Process::CLOCK_MONOTONIC) + REPAIR_TIMEOUT_SEC
+    status = nil
+    loop do
+      _, status = Process.waitpid2(pid, Process::WNOHANG)
+      break if status
+
+      if Process.clock_gettime(Process::CLOCK_MONOTONIC) > deadline
+        Process.kill("KILL", -pid) rescue nil
+        Process.waitpid2(pid) rescue nil
+        raise RepairFailed,
+              "the repair command timed out after #{REPAIR_TIMEOUT_SEC}s and was killed. " \
+              "The daemon may still be draining (TimeoutStopSec=900); check " \
+              "`hive daemon status` and re-run repair."
+      end
+      sleep 0.1
+    end
+
+    out = File.open(log.path, "rb") { |f| f.read(REPAIR_MAX_BYTES + 1) }
+             .to_s.force_encoding(Encoding::UTF_8).scrub
+    truncated = out.bytesize > REPAIR_MAX_BYTES
+    [ truncated ? out.byteslice(0, REPAIR_MAX_BYTES).scrub : out, truncated ]
+  ensure
+    log&.close
+    File.unlink(log.path) if log && File.exist?(log.path)
+  end
+end
